package com.sun.corba.se.impl.ior;

import com.sun.corba.se.spi.ior.IORTemplateList;
import com.sun.corba.se.spi.ior.IORFactory;
import org.omg.CORBA.portable.OutputStream;
import com.sun.corba.se.spi.ior.IORFactories;
import org.omg.PortableInterceptor.ObjectReferenceTemplateHelper;
import org.omg.CORBA.TypeCode;
import com.sun.corba.se.spi.orb.ORB;
import org.omg.CORBA.portable.InputStream;
import com.sun.corba.se.spi.ior.IORTemplate;
import org.omg.CORBA.portable.StreamableValue;
import org.omg.PortableInterceptor.ObjectReferenceTemplate;

public class ObjectReferenceTemplateImpl extends ObjectReferenceProducerBase implements ObjectReferenceTemplate, StreamableValue
{
    private transient IORTemplate iorTemplate;
    public static final String repositoryId = "IDL:com/sun/corba/se/impl/ior/ObjectReferenceTemplateImpl:1.0";
    
    public ObjectReferenceTemplateImpl(InputStream inputStream) {
        super((ORB)(ORB)inputStream.orb());
        this._read(inputStream);
    }
    
    public ObjectReferenceTemplateImpl(ORB orb, IORTemplate iorTemplate) {
        super(orb);
        this.iorTemplate = iorTemplate;
    }
    
    public boolean equals(Object o) {
        if (!(o instanceof ObjectReferenceTemplateImpl)) {
            return false;
        }
        ObjectReferenceTemplateImpl objectReferenceTemplateImpl = (ObjectReferenceTemplateImpl)o;
        return this.iorTemplate != null && this.iorTemplate.equals(objectReferenceTemplateImpl.iorTemplate);
    }
    
    public int hashCode() {
        return this.iorTemplate.hashCode();
    }
    
    public String[] _truncatable_ids() {
        return new String[] { "IDL:com/sun/corba/se/impl/ior/ObjectReferenceTemplateImpl:1.0" };
    }
    
    public TypeCode _type() {
        return ObjectReferenceTemplateHelper.type();
    }
    
    public void _read(InputStream inputStream) {
        org.omg.CORBA_2_3.portable.InputStream inputStream2 = (org.omg.CORBA_2_3.portable.InputStream)inputStream;
        this.iorTemplate = IORFactories.makeIORTemplate(inputStream2);
        this.orb = (ORB)(ORB)inputStream2.orb();
    }
    
    public void _write(OutputStream outputStream) {
        this.iorTemplate.write((org.omg.CORBA_2_3.portable.OutputStream)outputStream);
    }
    
    public String server_id() {
        return Integer.toString(this.iorTemplate.getObjectKeyTemplate().getServerId());
    }
    
    public String orb_id() {
        return this.iorTemplate.getObjectKeyTemplate().getORBId();
    }
    
    public String[] adapter_name() {
        return this.iorTemplate.getObjectKeyTemplate().getObjectAdapterId().getAdapterName();
    }
    
    @Override
    public IORFactory getIORFactory() {
        return this.iorTemplate;
    }
    
    @Override
    public IORTemplateList getIORTemplateList() {
        IORTemplateList iorTemplateList = IORFactories.makeIORTemplateList();
        iorTemplateList.add(this.iorTemplate);
        iorTemplateList.makeImmutable();
        return iorTemplateList;
    }
}
